/**
 * Not barn section of the farm scene.
 * @param {BreedingFarmController} controller The breeding farm controller.
 */
function NotBarn(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var disagreeId = "notBarnDisagreeB";
    var agreeId = "notBarnAgreeB";
    var attackId = "notBarnAttackB";

    var toDisagree = new NotBarnDisagree(ctrl);
    var toAgree = new NotBarnAgree(ctrl);
    var toAttack = new NotBarnAttack(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            You slowly nod, but at the same time you stammer out that you don't want to do it [i]here[/i].
                            While that table looks inviting, you mention you'd rather [i]do it[/i] inside of the house.
                            Unless she has a problem with that?
                            A confused look forms on the vixen's face.
                            It takes a few seconds for her to process what you just said.
                            It's like she doesn't know how to feel about your response.
                        [/p]
                        [p]
                            "[color=orange]In the house? Not here, on the table?[/color]" the vulpine finally asks.
                            You reply with a single, swift nod, full of conviction.
                            You would [b]really[/b] prefer a [i]cleaner[/i] environment than this dusty old barn.
                            The woman removes her hand from your shoulder, and straightens her back once more, her face no longer mere inches away from yours.
                            "[color=orange]You're not the first kobold I make that offer, you know.
                            You [i]are[/i], however, the first to...[/color]" She considers her words. "[color=orange]...[i]dislike[/i] the barn."[/color]"
                        [/p]
                        [p]
                            Your turn to feel conflicted.
                            You aren't sure whether the canine is complimenting or berating you.
                            Noticing your confusion, she shoots you a small grin and a wink.
                            "[color=orange]It's nice to meet a kobold with standards, for once.[/color]"
                            A mountain of doubt rolls off your shoulders, Cassidy's compliment striking every right note,
                            pushing all the buttons to make a prideful smile form on your face.
                            She's right.
                            You're not like the others.
                            You have [b]standards[/b].
                        [/p]
                        [p]
                            The female fox extends her arm towards you, offering her furred hand.
                            "[color=orange]To the house, then, you [i]demanding little lizard[/i]?[/color]"
                            Ignoring her jest, you eagerly grab her hand, and the two of you exit the barn together.
                        [/p]
                        [p]
                            You walk hand in hand towards the fancy mansion adjacent to the much older barn.
                            While you don't accidentally want to break the mood, you do think a little bit of smalltalk is in order.
                            Your lust may be sated soon, but that still leaves your burning curiosity unchecked.
                            You ask the vixen what [i]exactly[/i] it is she breeds here.
                            You never really [i]did[/i] get a good look at the inside of those pens.
                        [/p]
                        [p]
                            The canine takes a moment to think.
                            She speaks slowly, carefully selecting her words.
                            "[color=orange]Oh, you know.
                            Small, cute things.
                            Some people like keeping them as pets.
                            Others like eating them.
                            Me?
                            I like [b]sleeping[/b] with them.[/color]"
                        [/p]
                        [p]
                            You fail to pick up on the blatant hint contained within the fox's reply.
                            Still clueless, you begin to think.
                            A small, cute pet.
                            Rabbits?
                            People like eating rabbits.
                            And earlier on, you even thought that that might have been it.
                            But Cassidy wouldn't [i]fuck[/i] a bunny, [i]would she[/i]?
                            And if she [i]did[/i] sleep with animals, why would she tell you about it?
                        [/p]
                        [p]
                            As the two of you near the front door, you are just as confused as you were [i]before[/i] her suggestive comment.
                            With an inquisitive look on your face, you repeat your question: what [b]does[/b] she breed?
                            She rolls her eyes, clearly unamused by your lack of comprehension.
                            Still, you can [i]feel[/i] that she doesn't feel comfortable outright [i]saying[/i] it.
                        [/p]
                        [p]
                            Her smile turns into a nervous grin.
                            The vixen lets go of your hand, and takes a step forward, towards the door, her bare back facing you.
                            "[color=orange]Well...[/color]"
                            she begins, whilst deeply bending over, lifting her tail up high to give you a clear look at her furred rump,
                            the fertile loins placed in between her thick thighs distracting you more than a little, 
                            almost as if she's trying to trick you, to prevent you from focussing on her reply.
                            While your eyes are glued to to the vulpine's groin, sheer inquisitiveness wins out from arousal, your attention remaining on-point.
                            Finally, the answer is revealed to you.
                            "[color=orange]...[small]kobolds[/small]. I breed kobolds.[/color]"
                        [/p]
                        [p]
                            Oh.
                            [i]Oh[/i].
                            Wait.
                            What?
                            Kobolds?
                            Your kind?
                            She said she bred things for fucking, for selling them as pets, and for...[b]eating[/b]?!
                            Reaching into her boot, Cassidy produces a small metal object from her footwear.
                            The key to her house.
                            Looking back at you, she notices how upset you are.
                            She realizes her [i]distraction[/i] must not have worked.
                        [/p]
                        [p]
                            Stepping towards the door, the canine begins to ratify her actions as she fiddles with the lock, her tone changing considerably.
                            "[color=orange]I thought you knew.
                            They live good lives.
                            Without me, they'd probably be off robbing someone or dying in a ditch somewhere.
                            In the barn, they get to spend all day fucking eachother, and sometimes even [i]me[/i].
                            They get plenty of food, straw to keep them warm at night, heck, I even read them a bedtime story once every week.
                            Doesn't that sound like a good time, ${name}?[/color]"
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildDisagreeChoice() {
        var disabled = ctrl.notbarn.has() ? "disabled" : "";
        var isSelected = ctrl.notbarn.get() === NotBarnChoice.DISAGREE;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${disagreeId}" ${disabled}>Disagree</button>`;

        var tooltip = global.parser.parse(`No! Your kind is [b]more[/b] than just [b]cattle[/b]!`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 155px;");
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildAgreeChoice() {
        var disabled = ctrl.notbarn.has() ? "disabled" : "";
        var isSelected = ctrl.notbarn.get() === NotBarnChoice.AGREE;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${agreeId}" ${disabled}>Agree</button>`;
        var tooltip = global.parser.parse(`You don't want to ruin your chances of [i]getting some[/i]. Agree with the vixen.`);
        
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildAttackChoice() {
        var weapon = ctrl.misc.weapon();
        var disabled = ctrl.notbarn.has() || !weapon ? "disabled" : "";
        var isSelected = ctrl.notbarn.get() === NotBarnChoice.ATTACK;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${attackId}" ${disabled}>Attack her</button>`;

        var tooltip;
        if (weapon) {
            tooltip = global.parser.parse(`How [b]dare[/b] she keep your kind as [b]sex slaves[/b]?! Time to teach this bitch a lesson she won't soon forget.`);
        } else {
            tooltip = global.parser.parse(`You don't have any weapons to attack the woman with.`);
        }
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You: </div>`;
        choice += buildDisagreeChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildAgreeChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildAttackChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + disagreeId), $("#" + agreeId), $("#" + attackId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerDisagreeListener() {
        $("#" + disagreeId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.notbarn.set(NotBarnChoice.DISAGREE);
            loadNextPart(toDisagree);
        });
    }
    
    /**
     * Adds a listener to the button.
     */
    function registerAgreeListener() {
        $("#" + agreeId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.notbarn.set(NotBarnChoice.AGREE);
            loadNextPart(toAgree);
        });
    }
    
    /**
     * Adds a listener to the button.
     */
    function registerAttackListener() {
        $("#" + attackId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.notbarn.set(NotBarnChoice.ATTACK);
            loadNextPart(toAttack);
        });
    }
    

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "notBarn";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if(ctrl.barn.get() !== BreedingBarnChoice.NOTBARN) {
            return "";
        }
        global.ui.applyTheme("hamlet_day");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += buildChoice();
        part += toDisagree.build();
        part += toAgree.build();
        part += toAttack.build();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if(ctrl.barn.get() !== BreedingBarnChoice.NOTBARN) {
            return;
        }
        
        toDisagree.registerListeners();
        toAgree.registerListeners();
        toAttack.registerListeners();

        if (ctrl.notbarn.has()) {
            return;
        }

        registerDisagreeListener();
        registerAgreeListener();
        registerAttackListener();
    };
}

var NotBarnChoice = {
    DISAGREE: 1,
    AGREE: 2,
    ATTACK: 3
};
