/**
 * The Introduction scene. Shown after the big button in the title screen has been clicked.
 */
function Introduction() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var sceneId = "Introduction";
    var sceneName = "Introduction";
    var controller = new IntroductionController(sceneId);
    var builder = new IntroductionBuilder(controller);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds the tab as a HTML string.
     * @returns {string} The tab, as a HTML string.
     */
    function buildTab() {
        var tab = global.ui.buildGenericHeader();
        tab += builder.buildScene();
        tab += global.ui.buildGenericFooter();
        return tab;
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = sceneId;
    this.name = sceneName;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this scene.
     */
    this.load = function () {
        global.currentScene = that.id;
        global.currentSceneName = that.name;
        global.currentSceneFolder = that.subfolder ? that.subfolder : "";
        global.kobold.history.addToSceneStack(that.id);
        global.ui.applyTheme();
        var tab = buildTab();
        global.ui.loadToMain(tab);
        builder.registerListeners();
    };
}

global.sceneLoader.queueRegister(function () {
    var scene = new Introduction();
    global.sceneLoader.registerScene(scene.id, scene);
});
