/**
 * Flee section of Varanar, Night Two.
 * @param {NightTwoController} controller The Night Two controller.
 */
function NightTwoHideAttack(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new NightTwoHideAttackContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.nightTwo.alleyAttack = true;
        var toReturn = `[p]
                            This guy thinks he can just [b]piss[/b] all over whatever the hell he wants?!
                            Has he no decency?
                            No way.
                            You aren't going to let some [b]filthy human[/b] take a leak in your face, ontop of a bunch of barrels that aren't even his.
                            He might not [b]know[/b] you're down here, but that just means you have the advantage of surprise.
                            Time to teach this guy a lesson about keeping his dick in his pants until he gets home.
                        [/p]
                        [p]
                            While a puddle of urine steadily forms next to you, you slowly rise from your huddled-up position on the ground,
                            like a snake rearing its head before [b]striking[/b].
                            Your eyes set on the ruffian's considerable package, you make your move.
                            You leap forwards, bundling all of your [b]anger[/b] and [b]hatred[/b] into a single powerful [b]swipe[/b].
                            Your sharp claws [b]smack[/b] against the human's exposed balls, [b]tearing[/b] through his scrotum, 
                            [b]ripping[/b] open his sack, tearing his nuts directly from his groin, mangling his genitals to beyond recognition.
                        [/p]
                        [p]
                            Your fingers [b]bathe[/b] in the human's blood, which gushes liberally from the gaping hole left where his testicles used to be.
                            His senses dulled by alcohol, it takes the man a moment to [b]realize[/b] what the hell is going on.
                            Looking downwards, he stares at the remnants of what used to be his balls, laying limply on the ground,
                            blood starting to mix with the ever-expanding piss-puddle.
                            His jaw drops agape.
                            He lets out an uncharacteristic high-pitched squeak.
                            His eyes rolling into the back of his head, the scoundrel tumbles backwards, falling lifelessly to the cold, hard ground.
                            Unable to cope with the immense amount of pain, he loses his consciousness.
                            The ruffian faints, with his now neutered, blood-oozing flaccid cock still on full display.
                        [/p]
                        [p]
                            As soon as the hoodlum falls, you immediately rush past him towards the entry to the alleyway.
                            Luckily, none of his [i]friends[/i] seem to have noticed the sound of his body falling to the floor.
                            They have continued walking along the road, and are starting to disperse.
                            You wait for a few more minutes for them to leave the area completely.
                            After wiping your hands on the downed human's clothes, 
                            you quickly and quietly escape the scene,
                            swiftly making your way to a more [i]hospitable[/i] neighbourhood.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = ctrl.hideAttack.continued() ? "disabled" : "";
        var isSelected = ctrl.hideAttack.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.hideAttack.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.hide.get() !== NightTwoHideChoice.ATTACK) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.hideAttack.change();
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.hide.get() !== NightTwoHideChoice.ATTACK) {
            return;
        }

        next.registerListeners();

        if (ctrl.hideAttack.continued()) {
            return;
        }

        registerNextListener();
    };
}
